=== debian/changelog ===
codec2 (0.3.0.2080-1) unstable; urgency=low

  * Match new Fedora packaging

 -- A. Maitland Bottoms <bottoms@debian.org>  Sat, 09 May 2015 22:28:55 -0400

codec2 (0.0.0.389-1) unstable; urgency=low

  * Package from the codec2-dev subversion repository

 -- A. Maitland Bottoms <bottoms@debian.org>  Tue, 01 May 2012 12:05:20 -0400
