## codec2 0.4

=== CMakeLists.txt ===
--- 
+++ 
@@ -5,7 +5,7 @@
 # Please report questions, comments, problems, or patches to the freetel
 # mailing list: https://lists.sourceforge.net/lists/listinfo/freetel-codec2
 #
-project(codec2)
+project(codec2 C)
 
 cmake_minimum_required(VERSION 2.8)
 
@@ -35,7 +35,7 @@
 # file at some point.
 #
 set(CODEC2_VERSION_MAJOR 0)
-set(CODEC2_VERSION_MINOR 3)
+set(CODEC2_VERSION_MINOR 4)
 # Set to patch level if needed, otherwise leave FALSE.
 set(CODEC2_VERSION_PATCH FALSE)
 set(CODEC2_VERSION "${CODEC2_VERSION_MAJOR}.${CODEC2_VERSION_MINOR}")
@@ -53,7 +53,11 @@
 
 # Set default C++ flags.
 set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall")
-set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall")
+set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall -g -O2")
+set(CMAKE_C_FLAGS_DEBUG "${CMAKE_C_FLAGS}")
+set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS}")
+set(CMAKE_C_FLAGS_RELEASE "${CMAKE_C_FLAGS}")
+set(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS}")
 
 # -fPIC is implied on MinGW...
 if(NOT WIN32)
@@ -61,9 +65,12 @@
     set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fPIC")
 endif()
 
-
 message(STATUS "Build type is: " ${CMAKE_BUILD_TYPE})
-message(STATUS "Compiler Flags: " ${CMAKE_CXX_FLAGS})
+string(TOUPPER ${CMAKE_BUILD_TYPE} _FLAGS)
+if(NOT "_FLAGS" STREQUAL "NONE")
+    set(BUILD_FLAGS "${CMAKE_C_FLAGS_${_FLAGS}}")
+endif()
+message(STATUS "Compiler Flags: " ${BUILD_FLAGS})
 
 #
 # Setup Windows/MinGW specifics here.
@@ -92,10 +99,13 @@
 #
 option(BUILD_SHARED_LIBS
     "Build shared library. Set to OFF for static library." ON)
-option(UNITTEST "Build unittest binaries." OFF)
+# Unittest should be on for dev builds and off for releases.
+if(IS_DIRECTORY ${CMAKE_SOURCE_DIR}/unittest)
+    option(UNITTEST "Build unittest binaries." ON)
+endif()
 option(INSTALL_EXAMPLES "Install example code." OFF)
 if(INSTALL_EXAMPLES)
-    install(DIRECTORY octave raw script voicing wav
+    install(DIRECTORY octave raw script wav
         USE_SOURCE_PERMISSIONS
         DESTINATION ${CMAKE_INSTALL_DATADIR}/codec2)
 endif()
@@ -128,12 +138,12 @@
 include_directories(${PROJECT_BINARY_DIR})
 
 # CMake Package setup
-include(CMakePackageConfigHelpers)
-configure_package_config_file(cmake/codec2-config.cmake.in
-    ${CMAKE_CURRENT_BINARY_DIR}/codec2-config.cmake
-    INSTALL_DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/codec2
-    PATH_VARS CMAKE_INSTALL_INCLUDEDIR
-)
+#include(CMakePackageConfigHelpers)
+#configure_package_config_file(cmake/codec2-config.cmake.in
+#    ${CMAKE_CURRENT_BINARY_DIR}/codec2-config.cmake
+#    INSTALL_DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/codec2
+#    PATH_VARS CMAKE_INSTALL_INCLUDEDIR
+#)
 
 #
 # codec2 library
@@ -144,6 +154,19 @@
     # Pthread Library
     find_package(Threads REQUIRED)
     message(STATUS "Threads library flags: ${CMAKE_THREAD_LIBS_INIT}")
+
+    #
+    # Find speex library
+    #
+    message(STATUS "Looking for Speex DSP library.")
+    find_path(SPEEXDSP_INCLUDE_DIR speex/speex.h)
+    find_library(SPEEXDSP_LIBRARY speexdsp)
+    message(STATUS "  Speex DSP headers: ${SPEEXDSP_INCLUDE_DIR}")
+    message(STATUS "  Speex DSP library: ${SPEEXDSP_LIBRARY}")
+    if(NOT SPEEXDSP_INCLUDE_DIR AND NOT SPEEXDSP_LIBRARY)
+        message(FATAL_ERROR "Speex DSP library not found!")
+    endif()
+
     add_subdirectory(unittest)
 endif(UNITTEST)
