=== debian/changelog ===
codec2 (0.4-3) unstable; urgency=low

  * drop dh_acc to get reproducible builds

 -- A. Maitland Bottoms <bottoms@debian.org>  Fri, 11 Sep 2015 22:19:50 -0400

codec2 (0.4-2) unstable; urgency=low

  * install all header files
  * use dh_acc and abi-compliance-checker

 -- A. Maitland Bottoms <bottoms@debian.org>  Fri, 04 Sep 2015 22:21:32 -0400

codec2 (0.4-1) unstable; urgency=low

  * New upstream release 0.4
  * new 700B mode used in freedv 1.0 release
  * add watch file

 -- A. Maitland Bottoms <bottoms@debian.org>  Thu, 27 Aug 2015 22:17:41 -0400
