=== debian/control ===
--- 
+++ 
@@ -2,15 +2,15 @@
 Section: sound
 Priority: optional
 Maintainer: A. Maitland Bottoms <bottoms@debian.org>
-Build-Depends: debhelper (>= 9), cmake
+Build-Depends: cmake, debhelper (>= 9), libspeexdsp-dev
 Standards-Version: 3.9.6
 Homepage: http://www.rowetel.com/blog/?page_id=452
-Vcs-Git: git://git.debian.org/users/bottoms/codec2.git
-Vcs-Browser: http://git.debian.org/?p=users/bottoms/codec2.git;a=summary
+Vcs-Git: git://anonscm.debian.org/users/bottoms/pkg-codec2.git
+Vcs-Browser: http://anonscm.debian.org/cgit/users/bottoms/pkg-codec2.git/
 
 Package: codec2
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}
+Depends: ${misc:Depends}, ${shlibs:Depends}
 Description: command line tools for handling Codec2 data
  Codec2 is an audio codec especially designed for compressing voice at
  very low bit-rates for applications such as digital voice radio.
@@ -27,10 +27,10 @@
  .
  This package contains sample data and supporting examples.
 
-Package: libcodec2-0.3
+Package: libcodec2-0.4
 Architecture: any
 Pre-Depends: multiarch-support
-Depends: ${shlibs:Depends}, ${misc:Depends}
+Depends: ${misc:Depends}, ${shlibs:Depends}
 Multi-Arch: same
 Description: Codec2 runtime library
  Next-Generation Digital Voice for Two-Way Radio
@@ -44,7 +44,7 @@
 Architecture: any
 Section: libdevel
 Pre-Depends: multiarch-support
-Depends: libcodec2-0.3 (= ${binary:Version}), ${misc:Depends}
+Depends: libcodec2-0.4 (= ${binary:Version}), ${misc:Depends}
 Suggests: pkg-config
 Description: Codec2 library development files
  Codec2 is an audio codec especially designed for compressing voice at
